adopet/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('homepage.urls')),
    path('user/', include('user.urls')),
    path('admin-adopet/', include('adminadopet.urls')),
]

user/urls.py
from django.urls import path
from . import views

app_name = 'user'

urlpatterns = [
    path('form-request-open-donasi/', views.form_request_open_donasi, name='form_request_open_donasi'),
    path('detail-donasi/<id>/', views.detail_donasi, name='detail_donasi'),
    path('detail-donasi/<id>/melakukan-donasi/', views.melakukan_donasi, name='melakukan_donasi'),
    path('detail-donasi/<id>/list-donasi/', views.list_donasi, name='list_donasi'),
    path('detail-donasi/<id_donasi>/list-donasi/<id_pendonasian>/delete', views.delete_pendonasian, name='delete_pendonasian'),
    path('detail-donasi/<id_donasi>/list-donasi/<id_pendonasian>/berhasil', views.berhasil_donasi, name='berhasil_donasi'),
    path('form-open-adopt/', views.form_open_adopt, name='form_open_adopt'),
    path('detail-open-adopt/<id>/', views.detail_open_adopt, name='detail_open_adopt'),
    path('detail-open-adopt/<id>/buat-forum/', views.buat_forum, name='buat_forum'),
    path('detail-open-adopt/<id_hewan>/forum/<id_forum>/reply/', views.reply_forum, name='reply_forum'),
    path('detail-open-adopt/<id>/form-pengadopsian/', views.form_pengadopsian, name='form_pengadopsian'),
    path('detail-open-adopt/<id>/detail-pengadopsian/', views.detail_pengadopsian, name='detail_pengadopsian'),
    path('detail-open-adopt/<id_hewan>/detail-pengadopsian/<id_adopsi>/delete', views.delete_request_adopsi, name='delete_request_adopsi'),
    path('detail-open-adopt/<id_hewan>/detail-pengadopsian/<id_adopsi>/berhasil', views.berhasil_adopsi, name='berhasil_adopsi'),
    path('profil/', views.profil, name='profil'),
    path('form-request-artikel/', views.form_request_artikel, name='form_request_artikel'),
    path('', views.beranda, name='beranda'),
    path('berhasil-unggah/', views.berhasil_unggah, name='berhasil_unggah'),
    path('berhasil-request/', views.berhasil_request, name='berhasil_request'),
    path('detail-artikel/<id>/', views.detail_artikel, name='detail_artikel'),
    path('profil/buat-testimoni/', views.buat_testimoni, name='buat_testimoni'),
    path('chatpage/', views.chatpage, name='chatpage'),
    path('chatpage/send/<id_pengirim>/<id_penerima>', views.send_message, name='send_message'),
    path('list_hewan/', views.list_hewan, name='list_hewan'),
    path('list_foto/', views.list_foto, name='list_foto'),
    path('search/', views.search, name='search')
]

user/models.py
from django.db import models
from django.contrib.auth.models import User
from django.db.models.signals import post_save
from django.dispatch import receiver


class Hewan(models.Model):
    KATEGORI_HEWAN = [
        ("Kucing", "Kucing"),
        ("Anjing", "Anjing"),
        ("Kelinci", "Kelinci"),
        ("Burung", "Burung"),
        ("Ikan", "Ikan"),
        ("Hewan Pengerat", "Pengerat"),
        ("Unggas", "Unggas"),
        ("Reptil", "Reptil"),
        ("Lainnya", "Lainnya")
    ]

    JENIS_KELAMIN_HEWAN = [
        ("Jantan", "Jantan"),
        ("Betina", "Betina")
    ]

    nama_hewan = models.CharField(max_length = 50)
    jenis_hewan = models.CharField(max_length = 50)
    jenis_kelamin_hewan = models.CharField(max_length = 50, choices = JENIS_KELAMIN_HEWAN)
    usia_hewan = models.CharField(max_length = 50)
    domisili_hewan = models.CharField(max_length = 50)
    keterangan = models.CharField(max_length = 500, default = "")
    kategori = models.CharField(max_length = 50, choices = KATEGORI_HEWAN)
    kondisi_fisik_hewan = models.CharField(max_length = 500)
    kondisi_psikis_hewan = models.CharField(max_length = 500)
    mahar_adopsi = models.CharField(max_length = 500, default = "")

class FotoHewan(models.Model):
    foto = models.ImageField(upload_to='static/images/')
    hewan = models.ForeignKey(Hewan, on_delete=models.CASCADE)

class RequestAdopsi(models.Model):
    id_hewan = models.CharField(max_length = 50)
    nama_hewan = models.CharField(max_length = 50)
    nama_pengadopsi = models.CharField(max_length = 50)
    nomor_hp = models.CharField(max_length = 14)
    email_pengadopsi = models.CharField(max_length = 50)
    alamat_pengadopsi = models.CharField(max_length = 200)

class Donasi(models.Model):
    KATEGORI_HEWAN = [
        ("Kucing", "Kucing"),
        ("Anjing", "Anjing"),
        ("Kelinci", "Kelinci"),
        ("Burung", "Burung"),
        ("Ikan", "Ikan"),
        ("Hewan Pengerat", "Pengerat"),
        ("Unggas", "Unggas"),
        ("Reptil", "Reptil"),
        ("Lainnya", "Lainnya")
    ]

    JENIS_KELAMIN_HEWAN = [
        ("Jantan", "Jantan"),
        ("Betina", "Betina")
    ]

    nama_hewan = models.CharField(max_length = 50)
    jenis_hewan = models.CharField(max_length = 50)
    jenis_kelamin_hewan = models.CharField(max_length = 50, choices = JENIS_KELAMIN_HEWAN)
    usia_hewan = models.CharField(max_length = 50)
    domisili_hewan = models.CharField(max_length = 50)
    keterangan = models.CharField(max_length = 500, default = "")
    kategori = models.CharField(max_length = 50, choices = KATEGORI_HEWAN)
    kondisi_kesehatan = models.CharField(max_length = 500)
    lokasi_perawatan = models.CharField(max_length = 100)
    biaya_perawatan = models.CharField(max_length = 50, default = "")
    verifikasi = models.BooleanField(default = False)

class Testimoni(models.Model):
    NILAI = [
        ("0", "0"),
        ("1", "1"),
        ("2", "2"),
        ("3", "3"),
        ("4", "4"),
        ("5", "5"),
    ]
    nama_user = models.CharField(max_length = 50, default="admin")
    nilai_user = models.CharField(max_length = 50, choices = NILAI)
    komentar_user = models.CharField(max_length = 400)

class Artikel(models.Model):
    TAG = [
        ("Anjing", "Anjing"),
        ("Artikel", "Artikel"),
        ("Kucing", "Kucing"),
        ("Makanan", "Makanan")
    ]
    judul_artikel = models.CharField(max_length = 50)
    isi_artikel = models.CharField(max_length = 500)
    tag_artikel = models.CharField(max_length = 50)
    verifikasi_artikel = models.BooleanField(default = False)

class Pendonasian(models.Model):
    METODE = [
        ("gopay", "Gopay"),
        ("jenius", "Jenius"),
        ("linkaja", "Linkaja"),
        ("ovo", "OVO"),
        ("bca", "BCA"),
        ("bni", "BNI"),
        ("bri", "BRI"),
        ("mandiri", "Mandiri"),
        ("visa", "Visa")
    ]

    id_donasi = models.CharField(max_length = 50, default = "")
    nominal_donasi = models.CharField(max_length = 50)
    metode_donasi = models.CharField(max_length = 50, choices = METODE)
    nama_pendonasi = models.CharField(max_length = 50)
    hp_email = models.CharField(max_length = 50)
    dukungan = models.CharField(max_length = 500)

class Forum(models.Model):
    id_adopt = models.CharField(max_length = 50, default ="")
    judul_forum = models.CharField(max_length = 50)
    isi_forum = models.CharField(max_length = 500)

class ReplyForum(models.Model):
    id_forum = models.CharField(max_length = 50, default ="")
    reply_forum = models.CharField(max_length = 500)

class HistoryChat(models.Model):
    pengirim = models.CharField(max_length = 500, default ="")
    penerima = models.CharField(max_length = 500, default ="")
    datetimep = models.DateTimeField(auto_now=True)
    pesan = models.CharField(max_length = 999)

templates/openadopt/buat-forum.html
{% extends 'head.html' %}
{% block content_block %}
{% load static %}
<a type="button" onclick="location.href='/user/detail-open-adopt/{{hewan.id}}/'" class="btn btn-kembali"> < Kembali</a>
<div class="container">
	<div class="row justify-content-md-center">
		<p class="judul-form">Form Pembuatan Forum</p><br>
	</div>
	<form method="POST"> {% csrf_token %}
		<p class="form-label">Judul Forum :</p>
        <input type="text" class="form-control" name="judul_forum" required>
        <p class="form-label">Pertanyaan / Pernyataan :</p>
        <input type="text" class="form-control" name="isi_forum" required>
        <div class="row justify-content-center unggah">
			<button type="submit" class="btn btn-secondary">Kirim</button>
        </div>
    </form>
</div>
{% endblock content_block %}

templates/openadopt/detail-open-adopt.html
{% extends 'navbar.html' %}
{% block content_block %}
{% load static %}
<head>
    <link rel="stylesheet" href="https://www.w3schools.com/w3css/4/w3.css">
    <meta name="viewport" content="width=device-width, initial-scale=1">
	<link rel="stylesheet" href="{% static 'css/openadopt.css' %}" type="text/CSS">
</head>
<a href="{% url 'user:beranda' %}" class="btn btn-kembali"> < Kembali</a>
<div class="container">
	<div class="row justify-content-md-center">
		<p class="judul-post-adopsi">Pengadopsian Hewan</p><br>
	</div>
</div>
<div class="container">
    <div class="row justify-content-center">
        <div class="col-7">
            <p class="form-label">Nama Hewan :</p>
            <p class="jawaban">{{hewan.nama_hewan}}</p>
            <p class="form-label">Jenis Hewan :</p>
            <p class="jawaban">{{hewan.jenis_hewan}}</p>
            <p class="form-label">Jenis Kelamin Hewan :</p>
            <p class="jawaban">{{hewan.jenis_kelamin_hewan}}</p>
            <p class="form-label">Usia Hewan :</p>
            <p class="jawaban">{{hewan.usia_hewan}}</p>
            <p class="form-label">Domisili Hewan :</p>
            <p class="jawaban">{{hewan.domisili_hewan}}</p>
            <p class="form-label">Keterangan :</p>
            <p class="jawaban">{{hewan.keterangan}}</p>
            <p class="form-label">Kategori :</p>
            <p class="jawaban">{{hewan.kategori}}</p>
            <p class="form-label">Kondisi Fisik Hewan :</p>
            <p class="jawaban">{{hewan.kondisi_fisik_hewan}}</p>
            <p class="form-label">Kondisi Psikis Hewan :</p>
            <p class="jawaban">{{hewan.kondisi_psikis_hewan}}</p>
            <p class="form-label">Mahar Adopsi :</p>
            <p class="jawaban">{{hewan.mahar_adopsi}}</p>
        </div>
    </div>

    <div class="row justify-content-center unggah">      
        <div class="col">
            <a type="button" class="btn btn-adopsi" onclick="location.href='/user/detail-open-adopt/{{hewan.id}}/form-pengadopsian/'">Adopsi Hewan</a>  
            <a type="button" class="btn btn-adopsi" onclick="location.href='/user/detail-open-adopt/{{hewan.id}}/detail-pengadopsian/'">List Adopsi</a>
        </div>        
    </div>
</div>
<br><br>
<hr class="line">
<div class="container forum">
    <div>
        <div class="row justify-content-md-center">
            <h1 class="judul-form">Forum Q&A</h1><br>
        </div>
    </div>

    <div>
        <div class="list-forum">
        {% if forum %}
            {% for i in forum %}
            {% if i.id_adopt|stringformat:"s" == hewan.id|stringformat:"s" %}
            <div class="row justify-content-center">
                <div class="col-md-7">
                    <div class="w3-card-4" style="width:70%">
                        <header class="w3-container w3-light-grey">
                            <h3>{{i.judul_forum}}</h3>
                        </header>
                        <div class="w3-container">
                            <hr>
                            <p>{{i.isi_forum}}</p><br>
                        </div>
                        <div class="w3 container">
                            {% for j in replyforum %}
                            {% if j.id_forum|stringformat:"s" == i.id|stringformat:"s" %}
                            <p>{{j.reply_forum}}</p>
                            {% endif %}
                            {% endfor %}
                        </div>
                        <a type="button" class="w3-button w3-block w3-dark-grey" onclick="location.href='/user/detail-open-adopt/{{hewan.id}}/forum/{{i.id}}/reply/'">Reply Forum</a>
                    </div>
                </div>
            </div>
            {% endif %}
            {% endfor %}
        {% else %}
		<div class="container my-5 text-center">
			Sorry, there are no current posts.<br><strong>Check back soon!</strong>
		</div>
        {% endif %}
        </div>
    </div>
</div>
<div>
    <div class="row justify-content-center unggah">
        <a type= "button" class ="btn btn-adopsi" style="margin-bottom: 10vh;" onclick="location.href='/user/detail-open-adopt/{{hewan.id}}/buat-forum/'">Buat Forum</a>
    </div>
</div>
{% endblock content_block %}

templates/openadopt/detail-pengadopsian.html
{% extends 'navbar.html' %}
{% block content_block %}
{% load static %}
<head>
    <meta name="viewport" content="width=device-width, initial-scale=1">
	<link rel="stylesheet" href="{% static 'css/openadopt.css' %}" type="text/CSS">
</head>
<a type="button" onclick="location.href='/user/detail-open-adopt/{{hewan.id}}/'" class="btn btn-kembali"> < Kembali</a>
<div class="container">
    <div class="row justify-content-center">
        <div class="post-adopsi">
            <p class="judul-post-adopsi">List Request Pengadopsian</p>
            {% for i in pengadopsian %}
            {% if i.id_hewan|stringformat:"s" == hewan.id|stringformat:"s" %}
            <div style="border: 1px solid #002c3e; padding: 20px; margin-top: 20px;">
                <div class="col" style="margin-top: 3vh;">
                    <p>Nama Lengkap : {{i.nama_pengadopsi}}</p>
                    <p>Nomor HP : {{i.nomor_hp}}</p>
                    <p>Alamat Email : {{i.email_pengadopsi}}</p>
                    <p>Alamat Lengkap : {{i.alamat_pengadopsi}}</p>
                </div>
                <div class="row justify-content-center unggah">
                    <form method ="POST" action="{% url 'user:delete_request_adopsi' hewan.id i.id %}">{% csrf_token %}
                        <button type="submit" class="btn btn-listadopsi">Tolak</button>   
                    </form>
                    <form method ="POST" action="{% url 'user:berhasil_adopsi' hewan.id i.id %}">{% csrf_token %}
                        <button type="submit" class="btn btn-listadopsi">Unggah</button>
                    </form>  
                </div>
            </div>
            {% endif %}
            {% endfor %}
        </div>
	</div>
</div>
<br><br>
{% endblock content_block %}

templates/openadopt/form-open-adopt.html
{% extends 'head.html' %}

{% block content_block %}
<a href="{% url 'user:beranda' %}" class="btn btn-kembali"> < Kembali</a>
<div class="container">
	<div class="row justify-content-md-center">
		<p class="judul-form">Form Open Adopt</p><br>
	</div>
</div>
<form method="POST"> {% csrf_token %}
<div class="container">
    <div class="row justify-content-center">
        <div class="col-7">
            <label for="id_nama_hewan" class="form-label">Nama Hewan<span class="star">*</span> </label>
            <input type="text" id="id_nama_hewan" class="form-control" name="nama_hewan" required="">
            
            <label for="id_jenis_hewan" class="form-label">Jenis Hewan<span class="star">*</span> </label>
            <input type="text" id="id_jenis_hewan" class="form-control" name="jenis_hewan" required="">   
            
            <div class="form-group">
                <label for="id_jenis_kelamin_hewan" class="form-label">Jenis Kelamin Hewan<span class="star">*</span> </label>
                <select class="form-control" name="jenis_kelamin_hewan" required="" id="id_jenis_kelamin_hewan">
                    <option value="" selected="">Pilih Jenis Kelamin</option>
                    <option value="Jantan">Jantan</option>
                    <option value="Betina">Betina</option>
                </select>
            </div>

            <label for="id_usia_hewan" class="form-label">Usia Hewan<span class="star">*</span> </label>
            <input type="text" id="id_usia_hewan" class="form-control" name="usia_hewan" required="">   
            
            <label for="id_domisili_hewan" class="form-label">Domisili Hewan<span class="star">*</span> </label>
            <input type="text" id="id_domisili_hewan" class="form-control" name="domisili_hewan" required="">   
            
            <label for="id_keterangan" class="form-label">Keterangan</label>
            <input type="text" id="id_keterangan" class="form-control form-big" name="keterangan">   
            
            <div class="form-group">
                <label for="id_kategori" class="form-label">Kategori<span class="star">*</span> </label>
                <select class="form-control" name="kategori" required="" id="id_kategori">
                    <option value="" selected="">Pilih Kategori</option>
                    <option value="Kucing">Kucing</option>
                    <option value="Anjing">Anjing</option>
                    <option value="Kelinci">Kelinci</option>
                    <option value="Burung">Burung</option>
                    <option value="Ikan">Ikan</option>
                    <option value="Pengerat">Hewan Pengerat</option>
                    <option value="Unggas">Unggas</option>
                    <option value="Reptil">Reptil</option>
                    <option value="Lainnya">Lainnya</option>
                </select>
            </div>
            
            <label for="id_kondisi_fisik_hewan" class="form-label">Kondisi Fisik Hewan<span class="star">*</span> </label>
            <input type="text" id="id_kondisi_fisik_hewan" class="form-control form-big" name="kondisi_fisik_hewan" required="">  
            
            <label for="id_kondisi_psikis_hewan" class="form-label">Kondisi Psikis Hewan<span class="star">*</span> </label>
            <input type="text" id="id_kondisi_psikis_hewan" class="form-control form-big" name="kondisi_psikis_hewan" required="">  
            
            <label for="id_mahar_adopsi" class="form-label">Mahar Adopsi</label>
            <input type="text" id="id_mahar_adopsi" class="form-control" name="mahar_adopsi">  
        </div>
    </div>
    <div class="row justify-content-center unggah">
        <button type="submit" class="btn btn-secondary" style="margin-top: 15vh; margin-bottom: 10vh;">Unggah</button>
    </div>
</div>
</form>
{% endblock content_block %}

templates/openadopt/form-pengadopsian.html
{% extends 'navbar.html' %}
{% block content_block %}
{% load static %}
<head>
    <meta name="viewport" content="width=device-width, initial-scale=1">
	<link rel="stylesheet" href="{% static 'css/openadopt.css' %}" type="text/CSS">
</head>
<a type="button" onclick="location.href='/user/detail-open-adopt/{{hewan.id}}/'" class="btn btn-kembali"> < Kembali</a>
<div class="container">
	<div class="row justify-content-md-center">
		<p class="judul-post-adopsi">Form Pengadopsian {{pengadopsian.nama_hewan}}</p><br>
	</div>
</div>

<form method="POST">{% csrf_token %}
<div class="container">
	<div class="row justify-content-center">
		<div class="form-group">
			<div class="form-group1">
				<label for="nama-pengadopsi">Nama Lengkap :</label><br>
				<textarea style="resize: none;" class="form-control" name="nama_pengadopsi" cols="10" rows="1" placeholder="Tulis Nama Lengkapmu"></textarea>
			</div>
			<div class="form-group2">
				<label for="nomor-hp">Nomor HP :</label><br>
				<textarea style="resize: none;" class="form-control" name="nomor_hp" cols="10" rows="1" placeholder="Tulis Nomor HPmu"></textarea>
			</div>
			<div class="form-group3">
				<label for="alamat-pengadopsi">Alamat Email :</label>
				<textarea style="resize: none;" class="form-control" name="email_pengadopsi" cols="50" rows="3" placeholder="Tulis Emailmu Disini"></textarea>
			</div>
			<div class="form-group3">
				<label for="alamat-pengadopsi">Alamat Lengkap :</label>
				<textarea style="resize: none;" class="form-control" name="alamat_pengadopsi" cols="50" rows="4" placeholder="Tulis Alamatmu Disini"></textarea>
			</div>
		</div>
	</div>
	<div class="row justify-content-center unggah">
		<button type="submit" class="btn btn-secondary" href='detail-open-adopt/{{database.id}}/detail-pengadopsian/'>Request Adopsi</button>
	</div>
</div>
</form>
<br><br><br>
{% endblock content_block %}

templates/openadopt/reply-forum.html
{% extends 'head.html' %}
{% block content_block %}
{% load static %}
<a type="button" onclick="location.href='/user/detail-open-adopt/{{hewan.id}}/'" class="btn btn-kembali"> < Kembali</a>
<div class="container">
	<div class="row justify-content-md-center">
		<p class="judul-form">Reply Forum {{forum.id}}</p><br>
	</div>
	<form method="POST"> {% csrf_token %}
        <p class="form-label">Tuliskan reply-mu di bawah ini :</p>
        <input type="text" class="form-control" name="reply_forum" required>
        <div class="row justify-content-center unggah">
			<button type="submit" class="btn btn-secondary">Kirim</button>
        </div>
    </form>
</div>
{% endblock content_block %}